
(function (PL, $) {

PL.GL = (function () {

		 function _global() {

			var that = this;
			var finalCount = 0;

			this.Global = {};

			this.getFormData = function(formId){
			    var unindexed_array = $('#' + formId).serializeArray();
			    var indexed_array = {};

			    $.map(unindexed_array, function(n, i){
			        indexed_array[n['name']] = n['value'];
			    });

			    return indexed_array;
			};

			this.baseName = function(path){
				var fname = path.split('/');
			    fname = fname[fname.length-1].split('.');
			    return fname[0];
			}

			this.ajax = function(url,data,callback){

				PL.GL.updateProgress(40);

				var method = 'POST';
				var data = JSON.stringify(data);

				$.ajax({
	                url: url,
	                type: method,
	                data: data,
	                contentType: "application/json",
	                dataType: 'json',
	                success: function(res){

	                	PL.GL.updateProgress(99.99);
                		setTimeout(function(){PL.GL.updateProgress(100)},300);

						if(callback!=undefined){
	                		callback(res);
	                	}
	                }
                });
			}

			this.pushState = function(url){

				if (history.pushState){
						var state = {"url":url};
						history.pushState(state, url, url);
					}

			};

			var loadPage = function(){

				var onloadUrl = window.location.href;
				var onloaded = 0;

				//on click of any a tag link
				$(document).on('click','a',function(e){
					e.preventDefault();
					onloaded = 1;
					var url = $(this).attr('href');

					if(url=='#'){
						return;
					}

					window.scrollTo(0, 0);
					PL.GL.pushState(url);
					fetchJson(url);
				});

				//on pressing back button
				if (history.pushState){
					$(window).on("popstate", function(e) {
					    var url = window.location.href;
					    if(onloaded==1 || onloadUrl!=url){
					    	fetchJson(url);
					    }
					    onloaded = 1;
					});
				}
			}

			var fetchJson = function(url,callback){
				if(url.indexOf('?')>-1){
						url += '&';
					}else{
						url += '?';
					}

					url += 'format=json';
					finalCount = 0;

					PL.GL.updateProgress(40);

					$('#container').removeClass('active');

					 $.ajax({url: url, success: function(res){

					 	PL.GL.updateProgress(80);

			        	document.title = res.title;
			        	var html = {};

			        	for(var k in res.render){

			        		var hbs = res.render[k];
			        		$.ajax({
						        url: '/templates-' + res.version + '/'+hbs+'.hbs', //ex. js/templates/mytemplate.handlebars
						        cache: true,
						        success: function(data) {
			        		
			        			var fname = PL.GL.baseName($(this)[0]['url']);

			        			var template = Handlebars.compile(data);
									html[fname] = '<div id="' + fname + '">' + template(res) + '</div>';
						       		
						       		setTimeout(function(){finalFunc(res.render,res.view,html,res.title,callback)});;
						    }});	
			        	}

			    }});
			}

			this.updateProgress = function(percent){

				if(percent!=100){
					$('#overlay').css("left","0%");
					$('#loader').css('width',percent + '%');
				}
				else{
					$('#loader').css('width','0%');
					$('#overlay').css("left","-100%");
				}
			};

			var finalFunc = function(render,view,html,title,callback){
				
				finalCount++;

				if(render.length==finalCount)
				{
					PL.GL.updateProgress(99.99);
					setTimeout(function(){
						PL.GL.updateProgress(100);
						$('#container').addClass('active');
						if(callback!=undefined){
							callback();
						}
					},300);
					var out = '<h1>' + title + '</h1><div class="wrapper">';
					for(k in render)
			    	{
			    		var hbs = render[k];
			    		if(html[hbs]!=undefined)
			    		{
			    			out += html[hbs];
			    		}
			    	}

			    	out += '</div>';
			    	VIEW = view;
			    	$('body').attr('class',"c-" + view);
			    	$('#container').html(out);

				}
				else{
					var precent = parseInt(80 + ((20/render.length) * finalCount));
					PL.GL.updateProgress(precent);
				}
			}

			var init = (function () {			 
				loadPage();
			  })();			
		  }
		  
        return new _global();
    })();
})(window.PL = window.PL || {}, jQuery, undefined);
