var compressor = require('node-minify');
var fs = require('fs');
var conf = require('./conf');

conf.nodePath = __dirname + '/';
conf.rootPath = __dirname.split('/');
conf.rootPath.pop();
conf.rootPath = conf.rootPath.join('/') + '/';

var globalJs = [
  conf.nodePath + 'js/jquery-2.1.4.min.js',
  conf.nodePath + 'js/handlebars-4.0.4.min.js',
  conf.nodePath + 'helper/validate.js',
  conf.nodePath + 'helper/common.js',
  conf.nodePath + 'js/validation.js',
  conf.nodePath + 'js/site.js',
  conf.nodePath + 'js/default.js',
];


var globalCss = [
  conf.nodePath + 'css/font-awesome.min.css',
  conf.nodePath + 'css/common.css',
  conf.nodePath + 'css/header.css',
  conf.nodePath + 'css/pages.css',
  conf.nodePath + 'css/mediaqueries.css'
];


// Only concatenation of files (no compression) 
compressor.minify({
    compressor: 'no-compress',
    input: globalJs,
    output: conf.nodePath + 'js/global.js',
    callback: function(err, min){
      if(err){
        console.log(err);
        return;
      }
      console.log(conf.nodePath + 'js/global.js'); 
    }
});


if(conf.jsMinify==true)
{
  // Using Google Closure 
  compressor.minify({
      compressor: 'gcc',
      input: conf.nodePath + 'js/global.js',
      output: conf.nodePath + 'js/global_min.js',
      callback: function(err, min){
        if(err){
          console.log(err);
          return;
        }
        console.log('global.js ---> global_min.js');
      }
  });

}


// Only concatenation of files (no compression) 
compressor.minify({
    compressor: 'no-compress',
    input: globalCss,
    output: conf.nodePath + 'css/global.css',
    callback: function(err, min){
      console.log(err);
      console.log(conf.nodePath + 'css/global.css');
    }
});


if(conf.cssMinify==true)
{
  // Using YUI Compressor for CSS 
  compressor.minify({
      compressor: 'yui-css',
      input: conf.nodePath + 'css/global.css',
      output: conf.nodePath + 'css/global_min.css',
      callback: function(err, min){
        console.log(err);
        console.log(conf.nodePath + 'css/global_min.css');
      }
  });
}