var route = function(){

	this.process = function(global, path, view, req, res){
		var pageObj = new global[path]['page']();
		
		pageObj.site = new global.site;
		pageObj.validate = new global.validate;
		pageObj.common = new global.common;
		pageObj.sql = new global.sql;
		pageObj.site.obj = pageObj;
		pageObj.sql.obj = pageObj;
		pageObj.output = {};
		pageObj.currentProcess = 0;
		pageObj.global = global;
		pageObj.path = path;
		pageObj.view = view;
		pageObj.req = req;
		pageObj.res = res;
		pageObj.POST = {};
		pageObj.GET = {};

		if(req.body!=undefined && req.body!=null){
			pageObj.POST = req.body;
		}

		if(req.query!=undefined && req.query!=null){
			pageObj.GET = req.query;
		}

		if(pageObj.render==undefined){
			pageObj.render = [];
		}

		if(pageObj.process==undefined || pageObj.process.length==0){
			pageObj.process = [function($){$.final();}];
		}


		pageObj.output['view'] = view;
		pageObj.output['render'] = pageObj.render;
		pageObj.output['version'] = pageObj.global.version;
		pageObj.callback = this.processOutput;

		pageObj.totalProcess = pageObj.process;
		pageObj.final = function(){
			this.currentProcess++;
			if(this.currentProcess==this.totalProcess.length){

				if(pageObj.title!=undefined){
					pageObj.output['title'] = pageObj.title;
				}else{
					pageObj.output['title'] = null;
				}

				if(pageObj.desc!=undefined){
					pageObj.output['desc'] = pageObj.desc;
				}else{
					pageObj.output['desc'] = null;
				}

				if(this.GET['format']=='json'){
					this.res.send(this.output);
				}
				else{
					this.callback(this);
				}
			}
		}

		pageObj.mysql = global.mysqlConn;
		//pageObj.mysql.connect();

		for(var i in pageObj.POST){
			pageObj.POST[i] = pageObj.common.replaceLast(pageObj.mysql.escape(pageObj.POST[i]),"'","");
			pageObj.POST[i] = pageObj.POST[i].replace("'","");
		}

		for(var i in pageObj.GET){
			pageObj.GET[i] = pageObj.common.replaceLast(pageObj.mysql.escape(pageObj.GET[i]),"'","");
			pageObj.GET[i] = pageObj.GET[i].replace("'","");
		}

		pageObj.totalProcess.forEach(function(processFunction) { 
				processFunction(pageObj);
		});
		
	};

	this.processOutput = function(obj){
		
		var html = {};
		var Handlebars = obj.global['handleBar'];
		var version = obj.global.version;
		var cssFile = 'global.css';
		var jsFile = 'global.js';

		// insert header section
		obj.render.unshift('header');
		// insert footer section
		obj.render.push('footer');

		obj.render.forEach(function(hbs) {
				source = obj.global.templates[hbs + '.hbs'];
			    var template = Handlebars.compile(source);
				html[hbs] = '<div id="' + hbs + '">' + template(obj.output) + '</div>';
		});
		
		if(obj.global.conf.cssMinify==true){
			cssFile = 'global_min.css';
		}

		if(obj.global.conf.jsMinify==true){
			jsFile = 'global_min.js';
		}

		var output = '<!DOCTYPE html><html xmlns="http://www.w3.org/1999/xhtml" xml:lang="' + obj.lang + '" lang="' + obj.lang + '" ><head><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=1.0,user-scalable=no"><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="content-language" content="EN" /><meta http-equiv="x-dns-prefetch-control" content="on" /><meta name="robots" content="index,follow" /><meta name="googlebot" content="index,follow" /><meta name="Slurp" content="index,follow" />';
		
		output += '<title>' + obj.output['title'] + '</title>';

		if(obj.output['desc']!=undefined){
			output += '<meta name="description" content="' + obj.output['desc'] + '" />';
		}				
		output += '<link rel="stylesheet" href="/css-' + version  + '/' + cssFile + '">';

		output += '</head><body class="c-' + obj.view + '"><div class="body-bg"><img src="/css-' + version + '/images/bg.jpg"></div><div id="loader"></div><div id="overlay"></div>';


		obj.render.forEach(function(hbs) {

			if(hbs=='footer'){
				output += '</div></div>';
			}

			output += html[hbs];

			if(hbs=='header'){
				output += '<a href="/"><img class="header-bg-img" src="/css-' + version + '/images/header_bg.jpg"></a><div id="container"><h1>' + obj.output['title'] + '</h1><div class="wrapper">';
			}
		});

		output += '<script>var VIEW = \'' + obj.view + '\';</script><script type="text/javascript"  src="/js-' + version  + '/' + jsFile + '"></script>';

		output += '</body></html>';

		obj.res.send(output);		
	};



}

module.exports = route;